<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'login' => '\\StructType\\Login',
            'loginToken' => '\\StructType\\LoginToken',
            'credentials' => '\\StructType\\Credentials',
            'context' => '\\StructType\\Context',
            'encryptionContext' => '\\StructType\\EncryptionContext',
            'AbstractMedia' => '\\StructType\\AbstractMedia',
            'appLinkInfo' => '\\StructType\\AppLinkInfo',
            'callToActionInfo' => '\\StructType\\CallToActionInfo',
            'appLinkResult' => '\\StructType\\AppLinkResult',
            'deviceLinkCodeResult' => '\\StructType\\DeviceLinkCodeResult',
            'deviceAuthTokenResult' => '\\StructType\\DeviceAuthTokenResult',
            'userInfo' => '\\StructType\\UserInfo',
            'reportPlaySecondsResult' => '\\StructType\\ReportPlaySecondsResult',
            'albumArtUrl' => '\\StructType\\AlbumArtUrl',
            'positionInformation' => '\\StructType\\PositionInformation',
            'mediaCollection' => '\\StructType\\MediaCollection',
            'trackMetadata' => '\\StructType\\TrackMetadata',
            'streamMetadata' => '\\StructType\\StreamMetadata',
            'property' => '\\StructType\\Property',
            'dynamicData' => '\\StructType\\DynamicData',
            'behaviorsData' => '\\StructType\\BehaviorsData',
            'tagsData' => '\\StructType\\TagsData',
            'mediaMetadata' => '\\StructType\\MediaMetadata',
            'mediaList' => '\\StructType\\MediaList',
            'radioTrackList' => '\\StructType\\RadioTrackList',
            'lastUpdate' => '\\StructType\\LastUpdate',
            'relatedBrowse' => '\\StructType\\RelatedBrowse',
            'relatedText' => '\\StructType\\RelatedText',
            'relatedPlay' => '\\StructType\\RelatedPlay',
            'relatedActions' => '\\StructType\\RelatedActions',
            'extendedMetadata' => '\\StructType\\ExtendedMetadata',
            'genericAction' => '\\StructType\\GenericAction',
            'openUrlAction' => '\\StructType\\OpenUrlAction',
            'simpleHttpRequestAction' => '\\StructType\\SimpleHttpRequestAction',
            'rateItemAction' => '\\StructType\\RateItemAction',
            'itemRating' => '\\StructType\\ItemRating',
            'httpHeader' => '\\StructType\\HttpHeader',
            'httpHeaders' => '\\StructType\\HttpHeaders',
            'contentKey' => '\\StructType\\ContentKey',
            'getSessionId' => '\\StructType\\GetSessionId',
            'getSessionIdResponse' => '\\StructType\\GetSessionIdResponse',
            'getMetadata' => '\\StructType\\GetMetadata',
            'getMetadataResponse' => '\\StructType\\GetMetadataResponse',
            'getExtendedMetadata' => '\\StructType\\GetExtendedMetadata',
            'getExtendedMetadataResponse' => '\\StructType\\GetExtendedMetadataResponse',
            'getExtendedMetadataText' => '\\StructType\\GetExtendedMetadataText',
            'getExtendedMetadataTextResponse' => '\\StructType\\GetExtendedMetadataTextResponse',
            'getUserInfo' => '\\StructType\\GetUserInfo',
            'getUserInfoResponse' => '\\StructType\\GetUserInfoResponse',
            'rateItem' => '\\StructType\\RateItem',
            'rateItemResponse' => '\\StructType\\RateItemResponse',
            'search' => '\\StructType\\Search',
            'searchResponse' => '\\StructType\\SearchResponse',
            'getMediaMetadata' => '\\StructType\\GetMediaMetadata',
            'getMediaMetadataResponse' => '\\StructType\\GetMediaMetadataResponse',
            'getMediaURI' => '\\StructType\\GetMediaURI',
            'getMediaURIResponse' => '\\StructType\\GetMediaURIResponse',
            'createItem' => '\\StructType\\CreateItem',
            'createItemResponse' => '\\StructType\\CreateItemResponse',
            'deleteItem' => '\\StructType\\DeleteItem',
            'deleteItemResponse' => '\\StructType\\DeleteItemResponse',
            'getScrollIndices' => '\\StructType\\GetScrollIndices',
            'getScrollIndicesResponse' => '\\StructType\\GetScrollIndicesResponse',
            'getLastUpdate' => '\\StructType\\GetLastUpdate',
            'getLastUpdateResponse' => '\\StructType\\GetLastUpdateResponse',
            'reportStatus' => '\\StructType\\ReportStatus',
            'reportStatusResponse' => '\\StructType\\ReportStatusResponse',
            'setPlayedSeconds' => '\\StructType\\SetPlayedSeconds',
            'setPlayedSecondsResponse' => '\\StructType\\SetPlayedSecondsResponse',
            'reportPlaySeconds' => '\\StructType\\ReportPlaySeconds',
            'reportPlaySecondsResponse' => '\\StructType\\ReportPlaySecondsResponse',
            'reportPlayStatus' => '\\StructType\\ReportPlayStatus',
            'reportPlayStatusResponse' => '\\StructType\\ReportPlayStatusResponse',
            'reportAccountAction' => '\\StructType\\ReportAccountAction',
            'reportAccountActionResponse' => '\\StructType\\ReportAccountActionResponse',
            'getAppLink' => '\\StructType\\GetAppLink',
            'getAppLinkResponse' => '\\StructType\\GetAppLinkResponse',
            'getDeviceLinkCode' => '\\StructType\\GetDeviceLinkCode',
            'getDeviceLinkCodeResponse' => '\\StructType\\GetDeviceLinkCodeResponse',
            'getDeviceAuthToken' => '\\StructType\\GetDeviceAuthToken',
            'getDeviceAuthTokenResponse' => '\\StructType\\GetDeviceAuthTokenResponse',
            'refreshAuthToken' => '\\StructType\\RefreshAuthToken',
            'refreshAuthTokenResponse' => '\\StructType\\RefreshAuthTokenResponse',
            'getContentKey' => '\\StructType\\GetContentKey',
            'getContentKeyResponse' => '\\StructType\\GetContentKeyResponse',
            'createContainer' => '\\StructType\\CreateContainer',
            'createContainerResult' => '\\StructType\\CreateContainerResult',
            'createContainerResponse' => '\\StructType\\CreateContainerResponse',
            'addToContainer' => '\\StructType\\AddToContainer',
            'addToContainerResult' => '\\StructType\\AddToContainerResult',
            'addToContainerResponse' => '\\StructType\\AddToContainerResponse',
            'renameContainer' => '\\StructType\\RenameContainer',
            'renameContainerResult' => '\\StructType\\RenameContainerResult',
            'renameContainerResponse' => '\\StructType\\RenameContainerResponse',
            'deleteContainer' => '\\StructType\\DeleteContainer',
            'deleteContainerResult' => '\\StructType\\DeleteContainerResult',
            'deleteContainerResponse' => '\\StructType\\DeleteContainerResponse',
            'removeFromContainer' => '\\StructType\\RemoveFromContainer',
            'removeFromContainerResult' => '\\StructType\\RemoveFromContainerResult',
            'removeFromContainerResponse' => '\\StructType\\RemoveFromContainerResponse',
            'reorderContainer' => '\\StructType\\ReorderContainer',
            'reorderContainerResult' => '\\StructType\\ReorderContainerResult',
            'reorderContainerResponse' => '\\StructType\\ReorderContainerResponse',
            'customFault' => '\\StructType\\CustomFault',
        );
    }
}
