<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for openUrlAction StructType
 * @subpackage Structs
 */
class OpenUrlAction extends AbstractStructBase
{
    /**
     * The url
     * @var string
     */
    public $url;
    /**
     * Constructor method for openUrlAction
     * @uses OpenUrlAction::setUrl()
     * @param string $url
     */
    public function __construct($url = null)
    {
        $this
            ->setUrl($url);
    }
    /**
     * Get url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->url;
    }
    /**
     * Set url value
     * @param string $url
     * @return \StructType\OpenUrlAction
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($url, true), gettype($url)), __LINE__);
        }
        $this->url = $url;
        return $this;
    }
}
