<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for rateItemAction StructType
 * @subpackage Structs
 */
class RateItemAction extends AbstractStructBase
{
    /**
     * The rateItem
     * Meta information extracted from the WSDL
     * - ref: tns:rateItem
     * @var \StructType\RateItem
     */
    public $rateItem;
    /**
     * The shouldSkip
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $shouldSkip;
    /**
     * Constructor method for rateItemAction
     * @uses RateItemAction::setRateItem()
     * @uses RateItemAction::setShouldSkip()
     * @param \StructType\RateItem $rateItem
     * @param bool $shouldSkip
     */
    public function __construct(\StructType\RateItem $rateItem = null, $shouldSkip = null)
    {
        $this
            ->setRateItem($rateItem)
            ->setShouldSkip($shouldSkip);
    }
    /**
     * Get rateItem value
     * @return \StructType\RateItem|null
     */
    public function getRateItem()
    {
        return $this->rateItem;
    }
    /**
     * Set rateItem value
     * @param \StructType\RateItem $rateItem
     * @return \StructType\RateItemAction
     */
    public function setRateItem(\StructType\RateItem $rateItem = null)
    {
        $this->rateItem = $rateItem;
        return $this;
    }
    /**
     * Get shouldSkip value
     * @return bool|null
     */
    public function getShouldSkip()
    {
        return $this->shouldSkip;
    }
    /**
     * Set shouldSkip value
     * @param bool $shouldSkip
     * @return \StructType\RateItemAction
     */
    public function setShouldSkip($shouldSkip = null)
    {
        // validation for constraint: boolean
        if (!is_null($shouldSkip) && !is_bool($shouldSkip)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($shouldSkip, true), gettype($shouldSkip)), __LINE__);
        }
        $this->shouldSkip = $shouldSkip;
        return $this;
    }
}
