<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for reportPlaySecondsResult StructType
 * @subpackage Structs
 */
class ReportPlaySecondsResult extends AbstractStructBase
{
    /**
     * The interval
     * @var int
     */
    public $interval;
    /**
     * Constructor method for reportPlaySecondsResult
     * @uses ReportPlaySecondsResult::setInterval()
     * @param int $interval
     */
    public function __construct($interval = null)
    {
        $this
            ->setInterval($interval);
    }
    /**
     * Get interval value
     * @return int|null
     */
    public function getInterval()
    {
        return $this->interval;
    }
    /**
     * Set interval value
     * @param int $interval
     * @return \StructType\ReportPlaySecondsResult
     */
    public function setInterval($interval = null)
    {
        // validation for constraint: int
        if (!is_null($interval) && !(is_int($interval) || ctype_digit($interval))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($interval, true), gettype($interval)), __LINE__);
        }
        $this->interval = $interval;
        return $this;
    }
}
